package com.ldodds.twinkle.ui.components;

import java.io.File;

import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextArea;

import org.jdesktop.swingworker.SwingWorker;

import com.hp.hpl.jena.query.*;

/**
 * Basic methods for extracting the key query 
 * objects from a QueryFrame sub-class
 * 
 * @author ccslrd
 */
public interface QueryInterface {
	
	String getQueryString();
	void setQueryString(String query);
	void insertInQueryString(String query);
	Query getQuery() throws QueryException;
	
	JTextArea getQueryField();
	JTextArea getTextResultsBox();
	JTable getResultsTable();
	public BasicQueryFormOptions getOptions();
	
	QueryExecution getQueryExecution(Query query) throws QueryException;
	void setSwingWorker(SwingWorker<Object,String> worker);
	SwingWorker<Object,String> getSwingWorker();
	
	void setFile(File file);
	File getFile();
	
	JTabbedPane getTabbedPanel();
	void setBusy(boolean busy);
}
